import 'option.dart';
import 'terminal.dart';

final Terminal _terminal = const Terminal(); // instance variable, outside the class
// always uses the same instance of terminal


// all instances of prompter will share the same terminal
class Prompter {



  bool askBinary(String prompt) {
    final input = _ask("$prompt (y/n)", []);
    return input.contains("y");
  }

  askMultiple(String prompt, List<Option> options) {
    final input = _ask(prompt, options);
    try { // run body of try statement - if any error, it stops and asks user again
      return options[int.parse(input)].value;
    } catch (err) {
      return askMultiple(prompt, options); // automatically recursive?
    }
  }

  String _ask(String prompt, List<Option> options) {
    _terminal.clearScreen();
    _terminal.printPrompt(prompt);
    _terminal.printOptions(options);

    return _terminal.collectInput();
  }
}

/* Create instance of prompter, call prompter.ask, ask creates instance
then throw away that terminal. Extract the terminal declaration*/

