import 'dart:io'; // namespace what's imported
import 'option.dart';

class Terminal {
  const Terminal();


  void printPrompt(String prompt) {
    // stdout = new Stdout(); already done for us
    stdout.writeln(prompt);
  }

  void printOptions(List<Option> options) {
    options.asMap().forEach((index, option){
      stdout.writeln("[$index] - ${option.label}");
    });

    stdout.writeln("Enter a choice\n");
    stdout.write(">");
  }

  String collectInput() {
    return stdin.readLineSync();
  }

  void clearScreen() {
    if (Platform.isWindows) {
      stdout.write('\x1B[2J\x1B[0f');
    } else {
      stdout.write('\x1B[2J\x1B[3J\x1B[H');
    }
  }
}

// fields are sort of equivalent to state

// no point in creating multiple instances of standard out
// They automatically create an instance for us
// property called Stour in lower case. low case means it's an isntance of standard out class

// now in this scope

// prompt, options, input
// clear terminal windows